
#ifndef WIDGET_H
#define WIDGET_H

#include "..\ObjectPool\ObjectPool.h"
#include "..\ObjectRelationship\MultiObjectRelationship.h"
#include <WTypes.h>

namespace ghost{

	class WidgetImpl_;

	namespace widget{

		enum Message;
		class RelatedObject;

	} // namespace widget

	class Widget : public MultiObjectRelationship{
		WidgetImpl_* pImpl_;

	private:
		explicit Widget(HWND hWnd);
		explicit Widget(Widget* pParent);
		~Widget();
		Widget(const Widget&);
		Widget& operator =(const Widget&);

		// öܹWidget
		friend class ObjectPool<Widget>;
#pragma warning(push)
#pragma warning(disable:4396)
		friend void std::_Destroy(Widget _FARQ *);
#pragma warning(pop)

	public:
		static Widget* Create(HWND hWnd); // ؼ
		static Widget* Create(Widget* pParent); // ؼ
		void Destroy();

	protected: // ¼
		virtual void RelationshipCreated_(ObjectRelationship* pObject);
		virtual void RelationshipDestroyed_(ObjectRelationship* pObject);

	public:
		widget::RelatedObject* GetRelatedObject() const;

		HWND GetContainerWindow() const;
		Widget* GetRoot() const;
		bool IsRoot() const;

		void SetParent(Widget* const pNewParent);
		Widget* GetParent() const;

		bool InsertChild(Widget* const pChild);
		bool RemoveChild(Widget* const pChild);

	public:
		// ˴updateǿǷʾ
		// ΪģؼֻǴڿͻһ򣬵ıʱӦòԭor
		// ʹôȥػⲿ
		// ЩʵĲڲؼ£ڶԵؼʱܲҪ¡
		// ԲżǷµĿء
		void SetAbsoluteRect(const RECT& rect, bool update = true);
		void GetAbsoluteRect(RECT& rect);

		void Draw(HDC hDC);// ĿǰûвǷнܻ

	public: // ԽչĲ
		void LayoutChildren();
		void DrawChildren(HDC hDC);

	public:
		// Ϣ֮ʹΪӭwindowsϢķʽ
		int SendMessage(widget::Message message, void* param1 = 0, void* param2 = 0);

	};

} // namespace ghost

#endif // WIDGET_H