
#ifndef WIDGET_MARGIN_LAYOUT_CHILDREN_H
#define WIDGET_MARGIN_LAYOUT_CHILDREN_H

#include "WidgetMonopolisticLayoutChildren.h"
#include <map>
#include <WTypes.h>

namespace ghost{

	namespace widget{

		enum MarginLayoutAttribute{
			MARGIN_LAYOUT_KEEP_LEFT = 1,
			MARGIN_LAYOUT_KEEP_TOP = 2,
			MARGIN_LAYOUT_KEEP_RIGHT = 4,
			MARGIN_LAYOUT_KEEP_BOTTOM = 8,
		};

		class MarginLayoutChildren : public MonopolisticLayoutChildren{
		protected:
			typedef std::map<Widget*, int> WidgetMapAttributes;
			RECT oldRect_;
			WidgetMapAttributes widget_attributes_;

		public:
			MarginLayoutChildren();
			virtual ~MarginLayoutChildren(){}

		public:
			// ֻЧܱ
			bool AddLayoutWidget(Widget* pWidget, int attributes);
			// ԱΪ0ᱻƳ
			bool RemoveLayoutWidget(Widget* pWidget, int attributes = -1);
			// ԱΪ0ᱻƳᱻ
			bool ModifyLayoutWidget(Widget* pWidgett, int attributes);

			int GetWidgetAttributes(Widget* pWidget);

		public:
			virtual void Layout(Widget* pWidget);

		protected:
			virtual void RelationshipCreated_(ObjectRelationship* pObject);

		};

	} // namespace widget

} // namespace ghost

#endif // WIDGET_MARGIN_LAYOUT_CHILDREN_H