
#include "WidgetRelatedObject.h"
#include "Widget.h"
#include "..\ObjectRelationship\MonopolisticRelateObject.h"

namespace ghost{

	namespace widget{

		RelatedObject::RelatedObject(Widget* const pWidget)
			: pWidget_(pWidget)
		{

		}

		void RelatedObject::RelationshipCreated_(ObjectRelationship* pObject)
		{
			auto pNewLayoutChildren = dynamic_cast<LayoutChildren*>(pObject);
			if (pNewLayoutChildren)
			{
				layoutChildrens_.insert(pNewLayoutChildren);
				return;
			}
		}
		void RelatedObject::RelationshipDestroyed_(ObjectRelationship* pObject)
		{
			auto pLayoutChildren = dynamic_cast<LayoutChildren*>(pObject);
			if (pLayoutChildren)
			{
				layoutChildrens_.erase(pLayoutChildren);
				return;
			}
		}

	} // namespace widget

} // namespace ghost