
#include "WindowMessageAssistant.h"

namespace ghost{

	namespace wnd_msg_assistant{

		OnPaint::OnPaint(HWND h) 
			: hWnd_(h)
			, memDC_(NULL)
		{
			if (::IsWindow(hWnd_))
			{
				::BeginPaint(hWnd_, &ps_);
				RECT clientRect;
				::GetClientRect(hWnd_, &clientRect);
				int clientWidth = clientRect.right-clientRect.left;
				int clientHeight = clientRect.bottom-clientRect.top;

				memDC_ = ::CreateCompatibleDC(ps_.hdc);
				HBITMAP hBmp = ::CreateCompatibleBitmap(ps_.hdc, clientWidth, clientHeight);
				::SelectObject(memDC_, hBmp);
				::DeleteObject(hBmp);
			}
		}
		OnPaint::~OnPaint()
		{
			if (::IsWindow(hWnd_))
			{
				RECT clientRect;
				::GetClientRect(hWnd_, &clientRect);
				int clientWidth = clientRect.right-clientRect.left;
				int clientHeight = clientRect.bottom-clientRect.top;
				::BitBlt(ps_.hdc, 0, 0, clientWidth, clientHeight, memDC_, 0, 0, SRCCOPY);
				::DeleteDC(memDC_);
				::EndPaint(hWnd_, &ps_);
			}
		}

	} // namespace wnd_msg_assistant

} // namespace ghost