
#ifndef MONOPOLISTIC_RELATE_OBJECT_H
#define MONOPOLISTIC_RELATE_OBJECT_H

#include "ObjectRelationship.h"
#include "WidgetLayoutChildren.h"

namespace ghost{

	template<typename T>
	bool SetMonopolisticRelatedObject(T*& pOldObject, ObjectRelationship* pObject, ObjectRelationship* pRelatedObject)
	{
		auto pNewRelatedObject = dynamic_cast<T*>(pRelatedObject);
		if (!pNewRelatedObject)
		{
			return false;
		}
		// ƳԭйĶ
		pObject->DestroyRelationship(pOldObject);
		// ¹Ķ
		pOldObject = pNewRelatedObject;
		return true;
	}

	template<typename T>
	bool RemoveMonopolisticRelatedObject(T*& pOldObject, ObjectRelationship* pObject)
	{
		auto pRelatedObject = dynamic_cast<T*>(pObject);
		if (!pRelatedObject)// ƳһĶ
		{
			return false;
		}
		pOldObject = 0;
		return true ;
	}

} // namespace ghost

#endif // MONOPOLISTIC_RELATE_OBJECT_H