
#ifndef OBJECT_RELATIONSHIP_H
#define OBJECT_RELATIONSHIP_H

namespace ghost{

	class ObjectRelationship{
	protected:
		ObjectRelationship(){}

	public:
		virtual ~ObjectRelationship(){}

	private:
		ObjectRelationship(const ObjectRelationship&);
		ObjectRelationship& operator =(const ObjectRelationship&);

	public:
		bool CreateRelationship(ObjectRelationship* pObject)
		{
			if (!DoCreateRelationship_(pObject))
			{
				return false;
			}
			RelationshipCreated_(pObject);
			return true;
		}
		bool DestroyRelationship(ObjectRelationship* pObject)
		{
			if (!DoDestroyRelationship_(pObject))
			{
				return false;
			}
			RelationshipDestroyed_(pObject);
			return true;
		}

	protected:
		virtual bool DoCreateRelationship_(ObjectRelationship* /*pObject*/) = 0;
		virtual bool DoDestroyRelationship_(ObjectRelationship* /*pObject*/) = 0;

	protected:
		virtual void RelationshipCreated_(ObjectRelationship* /*pObject*/){}
		virtual void RelationshipDestroyed_(ObjectRelationship* /*pObject*/){}
	};

} // namespace ghost

#endif // OBJECT_RELATIONSHIP_H