
#ifndef SINGLE_OBJECT_RELATIONSHIP_H
#define SINGLE_OBJECT_RELATIONSHIP_H

#include "ObjectRelationship.h"

namespace ghost{

	class SingleObjectRelationship : public ObjectRelationship{
	protected:
		ObjectRelationship* pRelatedObject_;

	public:
		SingleObjectRelationship() : pRelatedObject_(0){}
		virtual ~SingleObjectRelationship()
		{
			DoDestroyRelationship_(pRelatedObject_);
		}

	public:
		ObjectRelationship* GetRelatedObject() const{return pRelatedObject_;}

	protected:
		virtual bool DoCreateRelationship_(ObjectRelationship* pObject)
		{
			if (pObject == pRelatedObject_)
			{
				return false;
			}
			if (this == pObject)
			{
				return false;
			}
			auto pOldRelatedObject = pRelatedObject_;
			pRelatedObject_ = 0;
			if (pOldRelatedObject)
			{
				pOldRelatedObject->DestroyRelationship(this);
			}
			pRelatedObject_ = pObject;
			if (pRelatedObject_)
			{
				pRelatedObject_->CreateRelationship(this);
			}
			return true;
		}
		virtual bool DoDestroyRelationship_(ObjectRelationship* pObject)
		{
			if (pObject != pRelatedObject_)
			{
				return false;
			}
			return CreateRelationship(0);
		}
	};

} // namespace ghost

#endif // SINGLE_OBJECT_RELATIONSHIP_H